<!-- Filter bar -->
<div class="container">
    <div class="cont">
        <p class="h3">Jetez un coup d'œil aux objets publiés! 👀 </p>
        <p class="lead"><strong>Recherchez-les par type, mot-clé ou avec une date</strong></p>
    </div>
    <form class="form-inline justify-content-center">
        <div class="form-group mx-2">
            <select class="form-control" id="select_type" [(ngModel)]="objectFilterParameter" name="select_type">
                <option value=-1>Par type --></option>
                <option *ngFor="let item of objectsMap;let indexOfelement=index;" [value]="indexOfelement+1">{{item}}
                </option>
            </select>
        </div>
        <div class="form-group mx-2">
            <label class="sr-only" for="myInput_keyword">Description</label>
            <input class="form-control" type="text" id="myInput_keyword" [(ngModel)]="descriptionFilterParameter"
                name="description" placeholder="Par description">
        </div>
        <div class="form-group mx-2">
            <select class="form-control" id="select_date" [(ngModel)]="dateFilterParameter" name="select_date">
                <option value=-1>Par date --></option>
                <option *ngFor="let item of dateMap;let indexOfelement=index;" [value]="indexOfelement">{{item}}
                </option>
            </select>
        </div>
        <div *ngIf="dateFilterParameter >= 4 && dateFilterParameter < dateMap.length" class="form-group mx-2">
            <input class="form-control" type="date" [value]="calendarPicker" id="myInput_date"
                [(ngModel)]="calendarPicker" name="calendar" min="2020-01-01" max="2020-12-31">
        </div>
        <div class="form-group mx-2">
            <!--Bouton appliquer filtre-->
            <div class="input-group-prepend">
                <button class="btn btn-bleu" type="button" (click)="filter()">Appliquer</button>
            </div>
        </div>
        <div class="form-group mx-2">
            <!--Bouton appliquer filtre-->
            <div class="input-group-prepend">
                <button class="btn btn-secondary" type="button" (click)="cleanFilter()">Vider filtre</button>
            </div>
        </div>
    </form>
    <!--Filter ends-->

    <!-- Main content -->
    <div *ngIf="loading" id="loading_spinner" class="text-center">
        <p class="lead"><strong>On y arrive... </strong>🤖</p>
        <div class="spinner-border text-primary" role="status">
            <span class="sr-only">Loading...</span>
        </div>
    </div>
    <div *ngIf="arrayAAfficher?.length > 0; else elseBlock" class="row justify-content-center">
        <div *ngFor="let objet of arrayAAfficher" class="card mx-3 my-3 photo">
            <div class="info-item" (click)="previewImage(objet.imagePath,objet.description)" data-toggle="modal"
                data-target="#photoModal">
                <div class="card-photo rounded">
                    <img [src]=" objet.imagePath=='false' ? 'assets/img/no_photo.PNG': getAddresIP()+objet.imagePath"
                        class="preview center-block" alt="Image de l'objet">
                </div>
                <div class="card-body pb-0 pt-1 px-2">
                    <p class="text-uppercase mb-0"><strong>{{objectsMap[objet.type-1]}}</strong></p>
                    <p class="card-text" style="min-height: 50px;"><small>
                            <strong>Description: </strong>
                            {{ objet.description | slice:0:60 }}{{ objet.description.length > 60 ? '...' : '' }}</small>
                    </p>
                </div>
                <div class="card-footer py-1 px-2">
                    <small class="text-muted">Publié le:
                        {{objet.date | date:'d MMM, y à H' }}h{{objet.date | date:'mm' }}</small>
                </div>
            </div>
            <div class="card-body py-1 px-0 mx-auto">
                <div class="form-group my-0">
                    <button type="button" class="btn btn-outline-dark mr-2 p-1" data-toggle="modal"
                        data-target="#mapModal" (click)="showMap(objet.latitude,objet.longitude)">
                        <span class="material-icons">
                            location_on
                        </span>
                    </button>
                    <button type="button" class="btn btn-bleu" data-toggle="modal"
                        (click)="setSelectedObject(objet._id)" data-target="#sendCodeModal">
                        Ceci est mon objet
                    </button>
                </div>
            </div>
        </div>
        <!--Object Photo Modal -->
        <div class="modal fade" id="photoModal" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel"
            aria-hidden="true">
            <div class="modal-dialog" role="document">
                <div class="modal-content">
                    <div class="modal-header">
                        <h5 class="modal-title" id="exampleModalLabel">Plus en détail</h5>
                        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                            <span aria-hidden="true">&times;</span>
                        </button>
                    </div>
                    <div class="modal-body">
                        <div class="col-sm-12 container-fluid">
                            <img [src]=" modalPath=='false' ? 'assets/img/no_photo.PNG': getAddresIP()+modalPath"
                                class="rounded mx-auto d-block total rounded" alt="Imge de l'objet">
                            <p class="text-justify mt-4 mb-0"><b>Description:</b> {{modalDescription}}</p>
                        </div>
                    </div>
                    <div class="modal-footer">
                        <button type="button" class="btn btn-bleu" data-dismiss="modal">Compris!</button>
                    </div>
                </div>

            </div>
        </div>
        <!-- Map Modal -->
        <div class="modal fade" id="mapModal" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel"
            aria-hidden="true">
            <div class="modal-dialog" role="document">
                <div class="modal-content">
                    <div class="modal-header">
                        <h5 class="modal-title" id="exampleModalLabel">L'objet a éte trouvé ici</h5>
                        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                            <span aria-hidden="true">&times;</span>
                        </button>
                    </div>
                    <div class="modal-body">
                        <div class="map-container">
                            <div style="height: 400px;" leaflet [leafletOptions]="options"
                                (leafletMapReady)="onMapReady($event)" (leafletMouseOver)="refreshMap()">
                            </div>
                        </div>
                    </div>
                    <div class="modal-footer">
                        <!-- <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button> -->
                        <button type="button" class="btn btn-primary" data-dismiss="modal">Compris!</button>
                    </div>
                </div>
            </div>
        </div>
        <!--Send Code Modal  -->
        <div class="modal fade" id="sendCodeModal" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel"
            aria-hidden="true">
            <div class="modal-dialog" role="document">
                <div class="modal-content">
                    <div class="modal-header">
                        <h5 class="modal-title">Il s'agît bien de votre objet?</h5>
                        <h5 class="modal-title" id="exampleModalLabel"></h5>
                        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                            <span aria-hidden="true">&times;</span>
                        </button>
                    </div>
                    <div class="modal-body">
                        <form [formGroup]="emailForm" (ngSubmit)="sendMail()" novalidate>
                            <div class="modal-body">
                                <p>Afin de vous mettre en contact avec la personne, veuillez ajouter votre adresse mail et/ou un numéro de téléphone.
                                </p>
                                <div *ngIf="errors.length > 0" class="notif">
                                    <div *ngFor="let error of errors" class="alert alert-danger alert-dismissible fade show" role="alert">
                                        <small><strong>{{error.text}}</strong> </small>
                                        <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                                            <span aria-hidden="true">&times;</span>
                                        </button>
                                    </div>
                                </div>
                                <div class="form-group">
                                    <label for="inputEmail">Mail de contact *</label>
                                    <div class="input-group mb-1">
                                        <input type="text" class="form-control" (keypress)="emailVal($event)"
                                            formControlName="email" placeholder="example@lost-found.fr" id="inputEmail"
                                            aria-label="Recipient's username" aria-describedby="basic-addon2"
                                            [ngClass]="{ 'is-invalid': emailForm.controls['email'].invalid && (emailForm.controls['email'].dirty || emailForm.controls['email'].touched)}">
                                    </div>
                                    <div class="form-control-feedback"
                                        *ngIf="emailForm.controls['email'].invalid && (emailForm.controls['email'].dirty || emailForm.controls['email'].touched)">
                                        <div style="color:red; font-size:small"
                                            *ngIf="emailForm.controls['email'].errors.pattern || emailForm.controls['email'].errors.required">
                                            Inserez un mail valide
                                        </div>
                                    </div>
                                </div>
                                <div class="form-group">
                                <label for="inputEmail">Confirmez votre mail *</label>
                                <div class="input-group mb-1">
                                    <input type="text" class="form-control" (keypress)="emailVal($event)"
                                        placeholder="example@lost-found.fr" id="inputEmail"
                                        formControlName="confirmEmail" aria-label="Confirmez le mail"
                                        aria-describedby="basic-addon2" [pattern]="f.email.value"
                                        [ngClass]="{ 'is-invalid': emailForm.controls['confirmEmail'].invalid && (emailForm.controls['confirmEmail'].dirty || emailForm.controls['confirmEmail'].touched)}">
                                </div>
                                <div class="form-control-feedback"
                                    *ngIf="emailForm.controls['confirmEmail'].invalid && (emailForm.controls['confirmEmail'].dirty || emailForm.controls['confirmEmail'].touched)">
                                    <div style="color:red; font-size:small"
                                        *ngIf="emailForm.controls['confirmEmail'].errors.required">
                                        Confirmez le mail
                                    </div>
                                    <div style="color:red; font-size:small"
                                        *ngIf="emailForm.controls['confirmEmail'].errors.pattern">
                                        Les adresses mail ne correspondent pas.
                                    </div>
                                </div>
                            </div>
                            <div class="form-group">
                                <!-- <label for="inputTelephone">Numéro de téléphone</label> -->
                                <div class="custom-control custom-checkbox mb-2">
                                    <input type="checkbox" class="custom-control-input" id="numberCheck"
                                        name="numberCheck" (change)="checkValue(isCheckedPhoneNumber?true:false)">
                                    <label class="custom-control-label" for="numberCheck">Ajouter un numéro de
                                        téléphone</label>
                                </div>

                                <div class="input-group mb-1">
                                    <input type="text" formControlName="number"
                                        [ng2TelInputOptions]="{initialCountry: 'fr',onlyCountries: objectService.flagsToShow,preferredCountries: ['fr','es','ch', 'de','it'],separateDialCode: true}"
                                        ng2TelInput class="form-control" (keypress)="numericOnly($event)"
                                        (countryChange)="onCountryChange($event)"
                                        [ngClass]="{ 'is-invalid': emailForm.controls['number'].invalid && isCheckedPhoneNumber && (emailForm.controls['number'].dirty || emailForm.controls['number'].touched)}">
                                </div>
                                <div class="form-control-feedback"
                                    *ngIf="emailForm.controls['number'].invalid && isCheckedPhoneNumber &&(emailForm.controls['number'].dirty || emailForm.controls['number'].touched)">
                                    <div style="color:red; font-size:small"
                                        *ngIf="emailForm.controls['number'].errors.required && isCheckedPhoneNumber">
                                        Numéro de téléphone requis
                                    </div>
                                </div>
                                <small>*Ces données seront tranmises à la personne qui a rétrouvé l'objet</small>
                            </div>
                                <div class="form-group text-center">
                                    <re-captcha (resolved)="resolved($event)" [formControl]="emailForm.controls['recaptcha']"
                                        [siteKey]="SITE_KEY"></re-captcha>
                                </div>

                            </div>
                            <div class="modal-footer">
                                <button type="button" class="btn btn-secondary" id="cancelSendMail"
                                    data-dismiss="modal">Annuler</button>
                                <button type="submit" [disabled]="emailForm.invalid" class="btn btn-warning">
                                    Envoyer mail!
                                </button>
                            </div>
                        </form>
                    </div>

                </div>



            </div>
        </div>
        <!-- Send Code Modal Ends -->

        <!-- Pagination -->
        <div class="col-sm-12">
            <nav aria-label="Page navigation example">
                <ul class="pagination justify-content-center">
                    <li class="{{hasPrevPage ? 'page-item' : 'page-item disabled'}}">
                        <a class="page-link" role="button" (click)="loadMoreObjects(currentPage-1)" tabindex="-1"
                            [class.aria-disabled]="hasPrevPage ? true : false">Précedent</a>
                    </li>

                    <li *ngFor="let i of fakeArrayTotalPages; let myIndex = index"
                        class="{{myIndex+1 == currentPage ? 'page-item active' : 'page-item'}}"><a class="page-link"
                            (click)="loadMoreObjects(myIndex+1)">{{myIndex+1}}</a></li>
                    <li class="{{hasNext ? 'page-item' : 'page-item disabled'}}">
                        <a class="page-link" (click)="loadMoreObjects(currentPage+1)"
                            [class.aria-disabled]="hasNext ? 'page-item' : 'page-item disabled'">Suivant</a>
                    </li>
                </ul>
            </nav>
        </div>
    </div>
    <ng-template #elseBlock>
        <span class="d-block p-2 bg-primary text-white rounded mt-3">
            <h2>Pas d'objets trouvés.</h2>
        </span>
    </ng-template>


</div>